#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "statements.h"
#include "keywords.h"

void pfpixel(char **statement)
{
  printf("	LDX ");
  printimmed(statement[2][0]);
  printf("%s\n",statement[2]);

  printf("	LDY ");
  printimmed(statement[3][0]);
  printf("%s\n",statement[3]);

  printf("	LDA #");
  if (!strncmp(statement[4],"flip",2)) printf("2\n");
  else if (!strncmp(statement[4],"off",2)) printf("2\n");
  else printf("0\n");

  printf("	jsr pfpixel\n");
}

void pfhline(char **statement)
{
  printf("	LDX ");
  printimmed(statement[2][0]);
  printf("%s\n",statement[2]);

  printf("	LDY ");
  printimmed(statement[3][0]);
  printf("%s\n",statement[3]);

  printf("	LDA ");
  printimmed(statement[4][0]);
  printf("%s\n",statement[4]);
  printf("	STA temp3\n");

  printf("	LDA #");
  if (!strncmp(statement[5],"flip",2)) printf("2\n");
  else if (!strncmp(statement[5],"off",2)) printf("2\n");
  else printf("0\n");

  printf("	jsr pfhline\n");
}

void pfvline(char **statement)
{
  printf("	LDX ");
  printimmed(statement[2][0]);
  printf("%s\n",statement[2]);

  printf("	LDY ");
  printimmed(statement[3][0]);
  printf("%s\n",statement[3]);

  printf("	LDA ");
  printimmed(statement[4][0]);
  printf("%s\n",statement[4]);
  printf("	STA temp3\n");

  printf("	LDA #");
  if (!strncmp(statement[5],"flip",2)) printf("2\n");
  else if (!strncmp(statement[5],"off",2)) printf("1\n");
  else printf("0\n");

  printf("	jsr pfvline\n");
}

void pfscroll(char **statement)
{
  printf("	LDA #");
  if (!strncmp(statement[2],"left",2)) printf("0\n");
  else if (!strncmp(statement[2],"right",2)) printf("1\n");
  else if (!strncmp(statement[2],"up\0",2)) printf("2\n");
  else if (!strncmp(statement[2],"down",2)) printf("4\n");
  else {fprintf(stderr,"pfscroll direction unknown\n");exit(1);}

  printf("	jsr pfscroll\n");
}

void doasm()
{
  char data[100];
  while (1) {
    if ( ((!fgets(data,100,stdin))
       || ( (data[0]<(unsigned char)0x3A) && (data[0]>(unsigned char)0x2F) )) 
          && (data[0] != 'e')) {
      prerror("Error: Missing \"end\" keyword at end of inline asm\n");
      exit(1);
    }
    if (!strncmp(data,"end\0",3)) break;
    printf("	%s\n",data);  

  }
}

void player(char **statement)
{
  int height=0,i=0; //calculating sprite height
  char label[20];
  char data[100];
  char bytes[1000];
  char byte[100];
  char pl=statement[1][6];
  bytes[0]='\0';
  sprintf(label,"player%s_%c\n",statement[0],pl);
  
  printf("	LDA #<%s\n",label);
  printf("	STA player%cpointer\n",pl);

  printf("	LDA #>%s\n",label);
  printf("	STA player%cpointer+1\n",pl);


  printf("	JMP .%sjump%c\n",statement[0],pl);
 
  while (1) {
    if ( ((!fgets(data,100,stdin))
       || ( (data[0]<(unsigned char)0x3A) && (data[0]>(unsigned char)0x2F) )) 
          && (data[0] != 'e')) {

      prerror("Error: Missing \"end\" keyword at end of player declaration\n");
      exit(1);
    }
    if (!strncmp(data,"end\0",3)) break;
    height++;
    sprintf(byte,"	.byte %s",data);  
    strcat(bytes,byte);
 //   printf("	.byte %s\n",data);  
 
  }

  // insert DASM stuff to prevent page-wrapping of player data
  printf(" if (<*) > (<(*+%d))\n	repeat ($100-<*)\n	nop\n	repend\n	endif\n",height);

  printf("%s\n",label);
  printf("	.byte 0\n");

  printf("%s\n",bytes);

  printf(".%sjump%c\n",statement[0],pl);
//  while (statement[2][i]!='\0') {

//    if (statement[2][i++]==',') height++;
//  }  
  printf("	LDA #%d\n",height);
  printf("	STA player%cheight\n",pl);
}

void doif(char **statement)
{
  int not=0;
  int i,j,k;
  int bit=0;
  char **cstatement; //conditional statement
  cstatement = (char **)malloc(sizeof(char*)*50);
  for (k=0;k<50;++k) cstatement[k]=(char*)malloc(sizeof(char)*50);
  for (k=0;k<50;++k) for (j=0;j<50;++j) cstatement[j][k]='\0';
  if (statement[2][0] == '!') {
    not=1;
    for (i=0;i<49;++i) {
      statement[2][i]=statement[2][i+1];
    }
  }
  if ( (!strncmp(statement[2],"joy\0",3)) 
   || (!strncmp(statement[2],"switch\0",6)) ) {
    printf("	jsr %s\n",statement[2]);
    if (statement[4][0]<(unsigned char)0x3A) {
      if (not) bne(statement[4]); else beq(statement[4]);
//printf("	BNE "); else printf("	BEQ ");
//      printf(".%s\n",statement[4]);
      return;
    }
    else // then statement
    {
      if (not) printf("	BEQ "); else printf("	BNE ");

      printf(".skip%s\n",statement[0]);
      // separate statement
      for (i=3;i<50;++i)
      {
        for (k=0;k<50;++k) {
          cstatement[i-3][k]=statement[i][k];
	}
      }
      keywords(cstatement);
      printf(".skip%s\n",statement[0]);
 
      return;      
    }
  }

  if  (!strncmp(statement[2],"collision(\0",10)) {
    if (!strncmp(statement[2],"collision(missile0,player1)\0",27)) {
      printf("	BIT CXM0P\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile0,player0)\0",27)) {
      printf("	BIT CXM0P\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(missile1,player0)\0",27)) {
      printf("	BIT CXM1P\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile1,player1)\0",27)) {
      printf("	BIT CXM1P\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(player0,playfield)\0",28)) {
      printf("	BIT CXP0FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player0,ball)\0",23)) {
      printf("	BIT CXP0FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(player1,playfield)\0",28)) {
      printf("	BIT CXP1FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player1,ball)\0",23)) {
      printf("	BIT CXP1FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(missile0,playfield)\0",29)) {
      printf("	BIT CXM0FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile0,ball)\0",24)) {
      printf("	BIT CXM0FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(missile1,playfield)\0",29)) {
      printf("	BIT CXM1FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile1,ball)\0",24)) {
      printf("	BIT CXM1FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(ball,playfield)\0",25)) {
      printf("	BIT CXBLPF\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player0,player1)\0",26)) {
      printf("	BIT CXPPMM\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile0,missile1)\0",28)) {
      printf("	BIT CXPPMM\n");
      bit=6;
    } // now repeat everything in reverse...


    else if (!strncmp(statement[2],"collision(player1,missile0)\0",27)) {
      printf("	BIT CXM0P\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player0,missile0)\0",27)) {
      printf("	BIT CXM0P\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(player0,missile1)\0",27)) {
      printf("	BIT CXM1P\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player1,missile1)\0",27)) {
      printf("	BIT CXM1P\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(playfield,player0)\0",28)) {
      printf("	BIT CXP0FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(ball,player0)\0",23)) {
      printf("	BIT CXP0FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(playfield,player1)\0",28)) {
      printf("	BIT CXP1FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(ball,player1)\0",23)) {
      printf("	BIT CXP1FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(playfield,missile0)\0",29)) {
      printf("	BIT CXM0FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(ball,missile0)\0",24)) {
      printf("	BIT CXM0FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(playfield,missile1)\0",29)) {
      printf("	BIT CXM1FB\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(ball,missile1)\0",24)) {
      printf("	BIT CXM1FB\n");
      bit=6;
    }
    else if (!strncmp(statement[2],"collision(playfield,ball)\0",25)) {
      printf("	BIT CXBLPF\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(player1,player0)\0",26)) {
      printf("	BIT CXPPMM\n");
      bit=7;
    }
    else if (!strncmp(statement[2],"collision(missile1,missile0)\0",28)) {
      printf("	BIT CXPPMM\n");
      bit=6;
    }




    else //error
    {
      fprintf(stderr, "Error: cannot parse line %s", statement[0]);
      exit(1);
    }


    if (statement[4][0]<(unsigned char)0x3A) {
      if (not) {if (bit==7) bmi(statement[4]); else bvs(statement[4]);}
      else {if (bit==7) bpl(statement[4]); else bvc(statement[4]);}
//{if (bit==7) printf("	BMI "); else printf("	BVS ");}
//      else {if (bit==7) printf("	BPL "); else printf("	BVC ");}
//      printf(".%s\n",statement[4]);
      return;
    }
    else // then statement
    {
      if (!not) {if (bit==7) printf("	BMI "); else printf("	BVS ");}
      else {if (bit==7) printf("	BPL "); else printf("	BVC ");}

      printf(".skip%s\n",statement[0]);
      // separate statement
      i=3;
      while (statement[i][0]!='\0')
      {
        cstatement[i-3]=statement[i++];
      }
      keywords(cstatement);
      printf(".skip%s\n",statement[0]);
 
      return;      
    }
  }



  
  printf("	LDA %s\n",statement[2]);
  printf("	CMP ");
  printimmed(statement[4][0]);
  printf("%s\n",statement[4]);
  if ((statement[6][0]<(unsigned char)0x3A) && 
      (statement[6][0]>(unsigned char)0x2F)){ // then linenumber
    if (statement[3][0] == '=') beq(statement[6]);
    if (!strcmp(statement[3],"<>")) bne(statement[6]);
    else if (statement[3][0] == '<') bcc(statement[6]);
    if (statement[3][0] == '>') bcs(statement[6]);
//    if (statement[3][0] == '=') printf ("     BEQ ");
//    if (!strcmp(statement[3],"<>")) printf ("     BNE ");
//    else if (statement[3][0] == '<') printf ("     BCC ");
//    if (statement[3][0] == '>') printf ("     BCS ");
  
//    printf(".%s\n",statement[6]);
  }
  else // then statement
  { // first, take negative of condition and branch around statement
    if (statement[3][0] == '=') printf ("     BNE ");
    if (!strcmp(statement[3],"<>")) printf ("     BEQ ");
    else if (statement[3][0] == '<') printf ("     BCS ");
    if (statement[3][0] == '>') printf ("     BCC ");
  
    printf(".skip%s\n",statement[0]);
    // separate statement

      // separate statement
      for (i=5;i<50;++i)
      {
        for (k=0;k<50;++k) {
          cstatement[i-5][k]=statement[i][k];
	}
      }
      keywords(cstatement);
      printf(".skip%s\n",statement[0]);
 
      return;      


//    i=4;
//    while (statement[i][0]!='\0')
//    {
//      cstatement[i-4]=statement[i++];
//    }
//    keywords(cstatement);
//    printf(".skip%s\n",statement[0]);
  }
}

void let(char **cstatement)
{
  int i,j=0;
  int score[6]={0,0,0,0,0,0};
  char **statement;
  statement = (char **)malloc(sizeof(char*)*50);

  if (!strncmp(cstatement[2],"=\0",1)) {
    for (i=10;i>0;--i) {
      statement[i+1]=cstatement[i];
    }
  }
  else statement=cstatement;
  if (!strncmp(statement[4],"rand\0",4)) {
    printf("	  JSR randomize\n");
  }
  else if ( (!strncmp(statement[2],"score\0",5))
            && (strncmp(statement[2],"scorec\0",6)))
  {
// break up into three parts
    if (statement[5][0] == '+')
    {
      printf("	SED\n");
      printf("	CLC\n");
      for (i=5;i>=0;i--)
      {
  	if (statement[6][i] != '\0') score[j]=number(statement[6][i]);
	score[j]=number(statement[6][i]);
	if ((score[j]<10) && (score[j]>=0)) j++;
      }
      printf("	LDA score+2\n");      
      printf("	ADC #$%d%d\n",score[1],score[0]);
      printf("	STA score+2\n");      
      printf("	LDA score+1\n");      
      printf("	ADC #$%d%d\n",score[3],score[2]);
      printf("	STA score+1\n");      
      printf("	LDA score\n");      
      printf("	ADC #$%d%d\n",score[5],score[4]);
      printf("	STA score\n");      
      printf("	CLD\n");
    }
    else if (statement[6][0] == '-')
    {
      printf("	SED\n");
      printf("	SEC\n");
      for (i=5;i>=0;i--)
      {
	if (statement[6][i] != '\0') score[j]=number(statement[6][i]);
	score[j]=number(statement[6][i]);
	if ((score[j]<10) && (score[j]>=0)) j++;
      }
      printf("	LDA score+2\n");      
      printf("	SBC #$%d%d\n",score[1],score[0]);
      printf("	STA score+2\n");      
      printf("	LDA score+1\n");      
      printf("	SBC #$%d%d\n",score[3],score[2]);
      printf("	STA score+1\n");      
      printf("	LDA score\n");      
      printf("	SBC #$%d%d\n",score[5],score[4]);
      printf("	STA score\n");      
      printf("	CLD\n");
    }
    else
    {
      for (i=5;i>=0;i--)
      {
	if (statement[4][i] != '\0') score[j]=number(statement[4][i]);
	score[j]=number(statement[4][i]);
	if ((score[j]<10) && (score[j]>=0)) j++;
      }
      printf("	LDA #$%d%d\n",score[1],score[0]);
      printf("	STA score+2\n");      
      printf("	LDA #$%d%d\n",score[3],score[2]);
      printf("	STA score+1\n");      
      printf("	LDA #$%d%d\n",score[5],score[4]);
      printf("	STA score\n");      
    }
    return;

  }
  else if ( (statement[6][0] == '1') && ((statement[6][1] > (unsigned char)0x39) 
          || (statement[6][1] < (unsigned char)0x30)) &&
          ((statement[5][0] == '+') || (statement[5][0] == '-')) && 
	  (!strncmp(statement[2], statement[4], 2)))
  {
    if (statement[5][0] == '+') printf("	INC ");
    else printf("	DEC ");
    printf("%s\n",statement[2]);
    return;
  }
  else 
  {
    printf("	LDA ");
    printimmed(statement[4][0]);
    printf("%s\n",statement[4]);
  }
  if (statement[5][0] != '\0') {
    if (statement[5][0] == '+') {
      printf("	CLC\n");
      printf("	ADC ");
      printimmed(statement[6][0]);
      printf("%s\n",statement[6]);
    }
    else if (statement[5][0] == '-') {
      printf("	SEC\n");
      printf("	SBC ");
      printimmed(statement[6][0]);
      printf("%s\n",statement[6]);
    }
    else if (statement[5][0] == '&') {
      printf("	AND ");
      printimmed(statement[6][0]);
      printf("%s\n",statement[6]);
    }
    else if (statement[5][0] == '^') {
      printf("	EOR ");
      printimmed(statement[6][0]);
      printf("%s\n",statement[6]);
    }
    else if (statement[5][0] == '|') {
      printf("	ORA ");
      printimmed(statement[6][0]);
      printf("%s\n",statement[6]);
    }
    else if (statement[5][0] == '*') {
      printf("	ASL\n");
    }
    else if (statement[5][0] == '/') {
      printf("	LSR\n");
    }
    else if (statement[5][0] == ':'){} // a colon separator means do nothing
    else 
    {
      fprintf(stderr, "Error: cannot parse line %s", statement[0]);
      exit(1);
    }

  }
  printf("	STA %s\n",statement[2]);
}

void dogoto(char **statement)
{
  printf("	JMP .%s\n",statement[2]);
}

void gosub(char **statement)
{
  printf("	JSR .%s\n",statement[2]);
}

void rem(char **statement)
{
  if (!strncmp(statement[2],"smartbranching\0",14))
  {
    if (!strncmp(statement[3],"on\0",2)) smartbranching=1;
    else smartbranching=0;
  }
}

void bmi(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bmi .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bpl .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bmi .%s\n",linenumber);
  printf(" endif\n");
}

void bpl(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bpl .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bmi .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bpl .%s\n",linenumber);
  printf(" endif\n");
}

void bne(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	BNE .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	beq .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	BNE .%s\n",linenumber);
  printf(" endif\n");
}

void beq(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	BEQ .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bne .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	BEQ .%s\n",linenumber);
  printf(" endif\n");
}

void bcc(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bcc .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bcs .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bcc .%s\n",linenumber);
  printf(" endif\n");
}

void bcs(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bcs .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bcc .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bcs .%s\n",linenumber);
  printf(" endif\n");
}

void bvc(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bvc .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bvs .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bvc .%s\n",linenumber);
  printf(" endif\n");
}

void bvs(char *linenumber)
{
  removeCR(linenumber);
  if (smartbranching) {
    printf(" if ((* - .%s) < 128) && ((* - .%s) > -128)\n	bvs .%s\n",linenumber,linenumber,linenumber);
    printf(" else\n	bvc .skip%s\n	jmp .%s\n",linenumber,linenumber);
    printf(".skip%s\n",linenumber);
  }
  else printf("	bvs .%s\n",linenumber);
  printf(" endif\n");
}

void drawscreen()
{
  printf("	jsr drawscreen\n");
}

void prerror(char *myerror)
{
  fprintf(stderr, "%s\n", myerror);
}

void printimmed(char value)
{
  if ((value == '$') || (value == '%')
     || (value < (unsigned char)0x3A)) printf("#");

}

int number(unsigned char value)
{
  return ((int)value)-48;
}

void removeCR(char *linenumber)  // remove trailing CR from string
{
  if ((linenumber[strlen(linenumber)-1]==(unsigned char)0x0A) ||
      (linenumber[strlen(linenumber)-1]==(unsigned char)0x0D))
      {linenumber[strlen(linenumber)-1]='\0';removeCR(linenumber);}
}
